"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.ActionMenu = ActionMenu;
var _phosphorReact = require("phosphor-react");
var _react = _interopRequireWildcard(require("react"));
var _styledComponents = _interopRequireWildcard(require("styled-components"));
var _style = require("../../style");
var _ = require("..");
var _excluded = ["actions", "children"];
var _templateObject, _templateObject2, _templateObject3, _templateObject4, _templateObject5, _templateObject6;
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }
function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
function _taggedTemplateLiteral(strings, raw) { if (!raw) { raw = strings.slice(0); } return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }
var ActionMenuDiv = _styledComponents.default.div(_templateObject || (_templateObject = _taggedTemplateLiteral(["\n    display: flex;\n    align-items: center;\n    position: relative;\n    width: fit-content;\n    user-select: none;\n"])));
var FadeInFromTop = (0, _styledComponents.keyframes)(_templateObject2 || (_templateObject2 = _taggedTemplateLiteral(["\n    0% {\n        transform: translateY(-4px);\n        opacity: 0;\n    }\n    100% {\n        transform: translateY(0px);\n        opacity: 1;\n    }\n"])));
var FadeInFromBottom = (0, _styledComponents.keyframes)(_templateObject3 || (_templateObject3 = _taggedTemplateLiteral(["\n    0% {\n        transform: translateY(4px);\n        opacity: 0;\n    }\n    100% {\n        transform: translateY(0px);\n        opacity: 1;\n    }\n"])));
var OverlayDiv = _styledComponents.default.div(_templateObject4 || (_templateObject4 = _taggedTemplateLiteral(["\n    position: absolute;\n    min-width: 200px;\n    ", ";\n    ", ";\n    ", ";\n    ", ";\n    padding: 8px 0px;\n    box-shadow: rgba(0, 0, 0, 8%) 0px 8px 16px;\n    background-color: ", ";\n    font-size: 14px;\n    display: flex;\n    flex-direction: column;\n    gap: 0px;\n    z-index: 10;\n    border-radius: 8px;\n    border: solid 1px ", ";\n    animation: ", " 150ms\n        cubic-bezier(0.07, 0.75, 0.54, 0.93);\n"])), function (props) {
  return props.top !== undefined && "top: ".concat(props.top + props.buttonHeight, "px;");
}, function (props) {
  return props.right !== undefined && "right: ".concat(props.right, "px;");
}, function (props) {
  return props.bottom !== undefined && "bottom: ".concat(props.bottom + props.buttonHeight, "px;");
}, function (props) {
  return props.left !== undefined && "left: ".concat(props.left, "px;");
}, _style.cv.bg_element1, _style.cv.border4, function (props) {
  return props.top !== undefined ? FadeInFromTop : FadeInFromBottom;
});
var ActionsDiv = _styledComponents.default.div(_templateObject5 || (_templateObject5 = _taggedTemplateLiteral(["\n    display: flex;\n    flex-direction: column;\n    gap: 0px;\n    width: 100%;\n    padding: 0px 0px;\n\n    border-bottom: solid 1px ", ";\n    padding-bottom: 6px;\n    margin-bottom: 6px;\n    &:last-child {\n        border-bottom: none;\n        margin-bottom: 0;\n        padding-bottom: 0;\n    }\n"])), _style.cv.border4);
var ActionDiv = _styledComponents.default.div(_templateObject6 || (_templateObject6 = _taggedTemplateLiteral(["\n    display: flex;\n    align-items: center;\n    justify-content: space-between;\n    padding: 2px 16px;\n    background-color: ", ";\n    cursor: pointer;\n    transition: 150ms;\n    user-select: none;\n    color: ", ";\n    font-size: 0.875rem;\n    line-height: 24px;\n    color: ", ";\n\n    &:hover {\n        color: ", ";\n        background-color: ", ";\n    }\n"])), _style.cv.bg_element1, function (props) {
  return props.color === 'red' ? _style.cv.red1 : _style.cv.text2;
}, _style.cv.text1, function (props) {
  return props.color === 'red' ? _style.cv.red1 : _style.cv.text1;
}, function (props) {
  return props.color === 'red' ? _style.cv.bg_red1 : _style.cv.bg_element2;
});
function Action(_ref) {
  var icon = _ref.icon,
    label = _ref.label,
    _onClick = _ref.onClick,
    _ref$color = _ref.color,
    color = _ref$color === void 0 ? 'normal' : _ref$color;
  return /*#__PURE__*/_react.default.createElement(ActionDiv, {
    onClick: function onClick() {
      return _onClick();
    },
    color: color
  }, /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, label, icon));
}
/**
 * 클릭했을 때 여러 버튼이 있는 오버레이를 표시하는 버튼입니다.
 *
 * \<Button\>에서 확장되었습니다.
 */
function ActionMenu(_ref2) {
  var _buttonRef$current;
  var actions = _ref2.actions,
    children = _ref2.children,
    props = _objectWithoutProperties(_ref2, _excluded);
  var _useState = (0, _react.useState)(false),
    _useState2 = _slicedToArray(_useState, 2),
    isOpen = _useState2[0],
    setIsOpen = _useState2[1];
  var _useState3 = (0, _react.useState)({}),
    _useState4 = _slicedToArray(_useState3, 2),
    direction = _useState4[0],
    setDirection = _useState4[1];
  var ref = (0, _react.useRef)(null);
  var buttonRef = (0, _react.useRef)(null);
  var overlayRef = (0, _react.useRef)(null);
  (0, _react.useEffect)(function () {
    function handleClickOutside(e) {
      if (ref.current && !ref.current.contains(e.target)) {
        setIsOpen(false);
      }
    }
    document.addEventListener('mousedown', handleClickOutside);
    return function () {
      document.removeEventListener('mousedown', handleClickOutside);
    };
  }, [ref]);
  var calcPos = (0, _react.useCallback)(function () {
    if (!ref.current) return;
    var pos = {};
    if (ref.current.getBoundingClientRect().right + 250 > (window.innerWidth >= 1200 ? (window.innerWidth - 1200) / 2 + 1200 : window.innerWidth)) {
      pos.right = 0;
    } else {
      pos.left = 0;
    }
    if (ref.current.getBoundingClientRect().bottom + 300 > window.innerHeight) {
      pos.bottom = 0;
    } else {
      pos.top = 0;
    }
    setDirection(pos);
  }, []);
  var ActionClick = function ActionClick(onClick) {
    setIsOpen(false);
    onClick();
  };
  return /*#__PURE__*/_react.default.createElement(ActionMenuDiv, {
    ref: ref
  }, /*#__PURE__*/_react.default.createElement(_.Button, _extends({}, props, {
    ref: buttonRef,
    onClick: function onClick(e) {
      calcPos();
      setIsOpen(!isOpen);
      if (props.onClick) props.onClick(e);
    }
  }), children), /*#__PURE__*/_react.default.createElement(_phosphorReact.IconContext.Provider, {
    value: {
      size: 16,
      weight: 'bold',
      color: _style.cv.text3
    }
  }, isOpen && /*#__PURE__*/_react.default.createElement(OverlayDiv, _extends({}, direction, {
    ref: overlayRef,
    buttonHeight: ((_buttonRef$current = buttonRef.current) === null || _buttonRef$current === void 0 ? void 0 : _buttonRef$current.offsetHeight) && buttonRef.current.offsetHeight + 4 || 34
  }), actions.map(function (e, i) {
    return /*#__PURE__*/_react.default.createElement(ActionsDiv, {
      key: i
    }, e.map(function (action, ii) {
      return /*#__PURE__*/_react.default.createElement(Action, _extends({
        key: ii
      }, action, {
        onClick: function onClick() {
          return ActionClick(action.onClick);
        }
      }));
    }));
  }))));
}