"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Button = void 0;
var _styledComponents = _interopRequireDefault(require("styled-components"));
var _phosphorReact = require("phosphor-react");
var _react = _interopRequireWildcard(require("react"));
var _spinner = require("../spinner");
var _buttonStyle = require("./buttonStyle");
var _linkContext = require("../../context/linkContext");
var _buttonTooltip = require("./buttonTooltip");
var _excluded = ["as", "children", "variant", "isLoading", "color", "size", "icon", "iconPosition", "onClick", "type", "borderRadius", "width", "disabled", "to", "tooltip"];
var _templateObject;
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }
function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
function _taggedTemplateLiteral(strings, raw) { if (!raw) { raw = strings.slice(0); } return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }
var StyledButton = _styledComponents.default.button(_templateObject || (_templateObject = _taggedTemplateLiteral(["\n    display: flex;\n    justify-content: center;\n    align-items: center;\n    user-select: none;\n    position: relative;\n    font-size: 14px;\n    border: 0;\n    text-decoration: none;\n    transition: 150ms;\n    font-weight: 500;\n    line-height: 20px;\n    gap: 8px;\n    cursor: pointer;\n    border-radius: ", "px;\n\n    &::after {\n        content: '';\n        position: absolute;\n        z-index: 1;\n        top: 0px;\n        right: 0px;\n        bottom: 0px;\n        left: 0px;\n        transition: 200ms;\n        display: block;\n        pointer-events: none;\n        border-radius: 4px;\n        outline: solid 2px transparent;\n    }\n\n    &:focus-visible {\n        outline: none;\n        transition: 200ms;\n\n        &::after {\n            top: -3px;\n            right: -3px;\n            bottom: -3px;\n            left: -3px;\n        }\n    }\n\n    &:disabled {\n        cursor: not-allowed;\n    }\n\n    ", ";\n    ", ";\n"])), function (props) {
  return props.$borderRadius;
}, function (props) {
  return _buttonStyle.sizeMap[props.$size];
}, function (props) {
  return _buttonStyle.colorMap[props.$variant][props.$color];
});

/**
 * 버튼
 */
var Button = /*#__PURE__*/_react.default.forwardRef(function (_ref, ref) {
  var _inputRef$current, _inputRef$current2, _inputRef$current3, _inputRef$current4, _inputRef$current5, _inputRef$current6, _inputRef$current7, _inputRef$current8, _inputRef$current9, _inputRef$current10, _inputRef$current11, _inputRef$current12, _inputRef$current13, _inputRef$current14, _inputRef$current15, _inputRef$current16;
  var as = _ref.as,
    children = _ref.children,
    _ref$variant = _ref.variant,
    variant = _ref$variant === void 0 ? 'default' : _ref$variant,
    _ref$isLoading = _ref.isLoading,
    isLoading = _ref$isLoading === void 0 ? false : _ref$isLoading,
    _ref$color = _ref.color,
    color = _ref$color === void 0 ? 'gray' : _ref$color,
    _ref$size = _ref.size,
    size = _ref$size === void 0 ? 'medium' : _ref$size,
    icon = _ref.icon,
    _ref$iconPosition = _ref.iconPosition,
    iconPosition = _ref$iconPosition === void 0 ? 'start' : _ref$iconPosition,
    _onClick = _ref.onClick,
    _ref$type = _ref.type,
    type = _ref$type === void 0 ? 'button' : _ref$type,
    borderRadius = _ref.borderRadius,
    _ref$width = _ref.width,
    width = _ref$width === void 0 ? 'fit-content' : _ref$width,
    _ref$disabled = _ref.disabled,
    disabled = _ref$disabled === void 0 ? false : _ref$disabled,
    to = _ref.to,
    tooltip = _ref.tooltip,
    props = _objectWithoutProperties(_ref, _excluded);
  var inputRef = (0, _react.useRef)(null);
  (0, _react.useImperativeHandle)(ref, function () {
    return inputRef.current;
  });
  var _useContext = (0, _react.useContext)(_linkContext.LinkContext),
    Link = _useContext.Link;
  var _useState = (0, _react.useState)(false),
    _useState2 = _slicedToArray(_useState, 2),
    isHover = _useState2[0],
    setIsHover = _useState2[1];

  // 아이콘
  var Icon;
  if (typeof icon === 'string') {
    Icon = /*#__PURE__*/_react.default.createElement("img", {
      src: icon,
      alt: ""
    });
  }
  var buttonChildren = /*#__PURE__*/_react.default.createElement(_phosphorReact.IconContext.Provider, {
    value: {
      size: 16,
      weight: 'bold'
    }
  }, isLoading && /*#__PURE__*/_react.default.createElement(_spinner.Spinner, {
    size: 16,
    color: "var(--local-color)"
  }), !isLoading && iconPosition === 'start' && (Icon || icon), !isLoading && children, !isLoading && iconPosition === 'end' && (Icon || icon));
  var iconOnly = !children && !!icon;
  if (Link && to && !as) {
    var _Element = Link || 'button';
    return /*#__PURE__*/_react.default.createElement(StyledButton, _extends({}, props, {
      ref: inputRef,
      $width: width,
      onClick: function onClick() {
        return _onClick && _onClick();
      },
      $color: color,
      $size: size,
      $variant: variant,
      type: type,
      $borderRadius: borderRadius || iconOnly ? 99999 : 4,
      disabled: disabled,
      $iconOnly: iconOnly,
      as: _Element,
      to: to,
      href: to,
      onMouseOver: function onMouseOver(e) {
        setIsHover(true);
        if (props.onMouseOver) props.onMouseOver(e);
      },
      onMouseOut: function onMouseOut(e) {
        setIsHover(false);
        if (props.onMouseOut) props.onMouseOut(e);
      }
    }), buttonChildren);
  }
  var Element = as || 'button';
  var PreButton = /*#__PURE__*/_react.default.createElement(StyledButton, _extends({}, props, {
    ref: inputRef,
    $width: width,
    onClick: function onClick(e) {
      return _onClick && _onClick(e);
    },
    $color: color,
    $size: size,
    $variant: variant,
    type: type,
    $borderRadius: borderRadius || iconOnly ? 99999 : 4,
    disabled: disabled,
    $iconOnly: iconOnly,
    as: Element,
    onMouseOver: function onMouseOver(e) {
      setIsHover(true);
      if (props.onMouseOver) props.onMouseOver(e);
    },
    onMouseOut: function onMouseOut(e) {
      setIsHover(false);
      if (props.onMouseOut) props.onMouseOut(e);
    }
  }), buttonChildren);
  if (tooltip) {
    var pos = {
      top: -1,
      right: -1,
      bottom: -1,
      left: -1
    };

    // x: inputRef.current?.getBoundingClientRect().left,
    // y: inputRef.current?.getBoundingClientRect().top,

    switch (tooltip.direction || 'top') {
      case 'right':
        pos.left = ((_inputRef$current = inputRef.current) === null || _inputRef$current === void 0 ? void 0 : _inputRef$current.offsetLeft) + ((_inputRef$current2 = inputRef.current) === null || _inputRef$current2 === void 0 ? void 0 : _inputRef$current2.offsetWidth);
        pos.top = ((_inputRef$current3 = inputRef.current) === null || _inputRef$current3 === void 0 ? void 0 : _inputRef$current3.offsetTop) + ((_inputRef$current4 = inputRef.current) === null || _inputRef$current4 === void 0 ? void 0 : _inputRef$current4.offsetHeight) / 2;
        break;
      case 'bottom':
        pos.left = ((_inputRef$current5 = inputRef.current) === null || _inputRef$current5 === void 0 ? void 0 : _inputRef$current5.offsetLeft) + ((_inputRef$current6 = inputRef.current) === null || _inputRef$current6 === void 0 ? void 0 : _inputRef$current6.offsetWidth) / 2;
        pos.top = ((_inputRef$current7 = inputRef.current) === null || _inputRef$current7 === void 0 ? void 0 : _inputRef$current7.offsetTop) + ((_inputRef$current8 = inputRef.current) === null || _inputRef$current8 === void 0 ? void 0 : _inputRef$current8.offsetHeight);
        break;
      case 'left':
        pos.right = document.documentElement.scrollWidth - ((_inputRef$current9 = inputRef.current) === null || _inputRef$current9 === void 0 ? void 0 : _inputRef$current9.offsetLeft) - ((_inputRef$current10 = inputRef.current) === null || _inputRef$current10 === void 0 ? void 0 : _inputRef$current10.offsetWidth);
        pos.top = ((_inputRef$current11 = inputRef.current) === null || _inputRef$current11 === void 0 ? void 0 : _inputRef$current11.offsetTop) + ((_inputRef$current12 = inputRef.current) === null || _inputRef$current12 === void 0 ? void 0 : _inputRef$current12.offsetHeight) / 2;
        break;
      case 'top':
      default:
        pos.left = ((_inputRef$current13 = inputRef.current) === null || _inputRef$current13 === void 0 ? void 0 : _inputRef$current13.offsetLeft) + ((_inputRef$current14 = inputRef.current) === null || _inputRef$current14 === void 0 ? void 0 : _inputRef$current14.offsetWidth) / 2;
        pos.bottom = document.body.offsetHeight - ((_inputRef$current15 = inputRef.current) === null || _inputRef$current15 === void 0 ? void 0 : _inputRef$current15.offsetTop) - ((_inputRef$current16 = inputRef.current) === null || _inputRef$current16 === void 0 ? void 0 : _inputRef$current16.offsetHeight);
        break;
    }
    var f = function f(e) {
      return e === -1 ? 'auto' : "".concat(e, "px");
    };
    var inset = "".concat(f(pos.top), " ").concat(f(pos.right), " ").concat(f(pos.bottom), " ").concat(f(pos.left));
    return /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, PreButton, isHover && /*#__PURE__*/_react.default.createElement(_buttonTooltip.ButtonToolTipBox, {
      text: tooltip.text,
      direction: tooltip.direction || 'top',
      pos: inset
    }));
  }
  return PreButton;
});
exports.Button = Button;