"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Switch = void 0;
var _react = _interopRequireDefault(require("react"));
var _styledComponents = _interopRequireWildcard(require("styled-components"));
var _style = require("../../style");
var _label = require("./label");
var _ = require("..");
var _templateObject, _templateObject2, _templateObject3, _templateObject4, _templateObject5;
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
function _taggedTemplateLiteral(strings, raw) { if (!raw) { raw = strings.slice(0); } return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }
var SwitchDiv = _styledComponents.default.div(_templateObject || (_templateObject = _taggedTemplateLiteral(["\n    display: flex;\n    align-items: center;\n    gap: 8px;\n"])));
var CircleAnimation = (0, _styledComponents.keyframes)(_templateObject2 || (_templateObject2 = _taggedTemplateLiteral(["\n    0% {\n        transform: scaleX(1)\n    }\n    50% {\n        transform: scaleX(1.3)\n    }\n    100% {\n        transform: scaleX(1)\n    }\n"])));
var Input = _styledComponents.default.input(_templateObject3 || (_templateObject3 = _taggedTemplateLiteral(["\n    appearance: none;\n\n    width: 44px;\n    height: 24px;\n    border-radius: 12px;\n    background: ", ";\n    display: flex;\n    align-items: center;\n    justify-content: center;\n    transition: 250ms;\n    position: relative;\n\n    cursor: ", ";\n\n    &:checked {\n        background-color: ", ";\n    }\n\n    ::after {\n        content: '';\n        position: absolute;\n        top: 3px;\n        left: 4px;\n        width: 18px;\n        height: 18px;\n        border-radius: 10px;\n        background-color: ", ";\n        transition: 250ms;\n    }\n\n    &:checked {\n        ::after {\n            left: 22px;\n            animation: ", " 250ms cubic-bezier(0, 0, 0.16, 0.99) forwards;\n        }\n    }\n"])), _style.cv.bg_element4, function (props) {
  return props.disabled ? 'not-allowed' : 'pointer';
}, _style.cv.blue1, _style.cv.white, CircleAnimation);
var Text = _styledComponents.default.div(_templateObject4 || (_templateObject4 = _taggedTemplateLiteral(["\n    display: block;\n    font-size: 14px;\n    color: ", ";\n    margin-bottom: 4px;\n\n    ", "\n"])), _style.cv.text3, function (props) {
  return props.required && (0, _styledComponents.css)(_templateObject5 || (_templateObject5 = _taggedTemplateLiteral(["\n            ::after {\n                content: ' *';\n            }\n        "])));
});
/**
 * \<Checkbox\>를 변형하여 스위치 형태로 표시하는 컴포넌트입니다.
 */
var Switch = /*#__PURE__*/_react.default.forwardRef(function (props, ref) {
  var style = {
    backgroundColor: '',
    backgroundColorHover: '',
    borderColor: '',
    borderColorHover: ''
  };
  return /*#__PURE__*/_react.default.createElement(_.Flex, {
    style: {
      flexDirection: 'column'
    }
  }, props.label && /*#__PURE__*/_react.default.createElement(_label.Label, {
    required: props.required || false
  }, props.label), /*#__PURE__*/_react.default.createElement(SwitchDiv, null, /*#__PURE__*/_react.default.createElement(Input, _extends({
    type: "checkbox"
  }, style, props, {
    ref: ref,
    onChange: props.onChange
  })), /*#__PURE__*/_react.default.createElement(Text, {
    required: props.required || false
  }, props.text)));
});
exports.Switch = Switch;