"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.ItemsTable = void 0;
var _react = _interopRequireDefault(require("react"));
var _phosphorReact = require("phosphor-react");
var _styledComponents = _interopRequireDefault(require("styled-components"));
var _style = require("../../style");
var _items = require("./items");
var _templateObject, _templateObject2;
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function _taggedTemplateLiteral(strings, raw) { if (!raw) { raw = strings.slice(0); } return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }
var StyledTable = _styledComponents.default.div(_templateObject || (_templateObject = _taggedTemplateLiteral(["\n    margin-top: 8px;\n    border-top: solid 1px ", ";\n    border-bottom: solid 1px ", ";\n    border-radius: 8px;\n"])), _style.cv.border4, _style.cv.border4);
function ItemsTableComponent(_ref) {
  var children = _ref.children;
  return /*#__PURE__*/_react.default.createElement(StyledTable, null, /*#__PURE__*/_react.default.createElement(_phosphorReact.IconContext.Provider, {
    value: {
      size: 36,
      weight: 'regular',
      color: _style.cv.border1
    }
  }, children));
}
ItemsTableComponent.displayName = 'ItemsTable';
var StyledRow = _styledComponents.default.div(_templateObject2 || (_templateObject2 = _taggedTemplateLiteral(["\n    position: relative;\n    display: flex;\n    align-items: center;\n    justify-content: space-between;\n    padding: 16px;\n    gap: 8px;\n    border-right: solid 1px ", ";\n    border-left: solid 1px ", ";\n    border-top: solid 1px ", ";\n\n    @media (max-width: 767px) {\n        flex-direction: column;\n        align-items: flex-start;\n        justify-content: flex-start;\n        padding: 16px;\n        gap: 8px;\n    }\n\n    &:first-of-type {\n        border-top: none;\n        border-top-left-radius: 8px;\n        border-top-right-radius: 8px;\n    }\n\n    &:last-child {\n        border-bottom-left-radius: 8px;\n        border-bottom-right-radius: 8px;\n    }\n"])), _style.cv.border4, _style.cv.border4, _style.cv.border4);
StyledRow.displayName = 'ItemsTable.Row';
var Row = Object.assign(StyledRow, _items.Item);

/**
 * 여러 아이템을 표 형식으로 표시하는 컴포넌트입니다.
 */
var ItemsTable = Object.assign(ItemsTableComponent, {
  Row: Row
});
exports.ItemsTable = ItemsTable;