"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.AvatarItem = AvatarItem;
var _react = _interopRequireDefault(require("react"));
var _styledComponents = _interopRequireDefault(require("styled-components"));
var _style = require("../../../style");
var _templateObject, _templateObject2, _templateObject3, _templateObject4, _templateObject5;
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function _taggedTemplateLiteral(strings, raw) { if (!raw) { raw = strings.slice(0); } return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }
var AvatarDiv = _styledComponents.default.div(_templateObject || (_templateObject = _taggedTemplateLiteral(["\n    display: flex;\n    align-items: center;\n    gap: 8px;\n    flex: ", ";\n    width: 100%;\n"])), function (props) {
  return props.flex || 1;
});
var AvatarIcon = _styledComponents.default.img(_templateObject2 || (_templateObject2 = _taggedTemplateLiteral(["\n    border-radius: 999px;\n    background-color: ", ";\n\n    width: 36px;\n    height: 36px;\n"])), _style.cv.bg_element2);
var AvatarInfo = _styledComponents.default.div(_templateObject3 || (_templateObject3 = _taggedTemplateLiteral(["\n    display: flex;\n    flex-direction: column;\n    gap: 2px;\n"])));
var AvatarName = _styledComponents.default.div(_templateObject4 || (_templateObject4 = _taggedTemplateLiteral(["\n    color: ", ";\n    font-size: 14px;\n    line-height: 17px;\n"])), _style.cv.text1);
var AvatarLabel = _styledComponents.default.div(_templateObject5 || (_templateObject5 = _taggedTemplateLiteral(["\n    font-size: 14px;\n    color: ", ";\n"])), _style.cv.text2);

/**
 * icon, name, label을 표시할 수 있는 아이템입니다.
 */
function AvatarItem(_ref) {
  var flex = _ref.flex,
    icon = _ref.icon,
    name = _ref.name,
    label = _ref.label;
  return /*#__PURE__*/_react.default.createElement(AvatarDiv, {
    flex: flex
  }, typeof icon === 'string' ? /*#__PURE__*/_react.default.createElement(AvatarIcon, {
    src: icon,
    alt: ""
  }) : icon, /*#__PURE__*/_react.default.createElement(AvatarInfo, null, name && /*#__PURE__*/_react.default.createElement(AvatarName, null, name), label && /*#__PURE__*/_react.default.createElement(AvatarLabel, null, label)));
}
// AvatarItem.displayName = 'ItemsTable.Row.Avatar';