"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Link = void 0;
var _phosphorReact = require("phosphor-react");
var _react = _interopRequireWildcard(require("react"));
var _styledComponents = _interopRequireWildcard(require("styled-components"));
var _linkContext = require("../../context/linkContext");
var _style = require("../../style");
var _excluded = ["as", "to", "color", "newTab", "showIcon", "children", "showUnderline"];
var _templateObject, _templateObject2, _templateObject3;
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
function _taggedTemplateLiteral(strings, raw) { if (!raw) { raw = strings.slice(0); } return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }
var LinkStyle = (0, _styledComponents.css)(_templateObject || (_templateObject = _taggedTemplateLiteral(["\n    color: ", ";\n    text-decoration: none;\n    font-size: 0.875rem;\n    line-height: 24px;\n    cursor: pointer;\n    border-bottom: solid 1px rgba(0, 0, 0, 0);\n"])), _style.cv.blue1);
var StyledLink = _styledComponents.default.a(_templateObject2 || (_templateObject2 = _taggedTemplateLiteral(["\n    /*\n        \uB9CC\uC57D showUnderline \uC55E\uC5D0 $\uB97C \uBD99\uC774\uC9C0 \uC54A\uC73C\uBA74 \uD574\uB2F9 prop\uC774 a \uD0DC\uADF8\uB85C \uC804\uD574\uC9C0\uAE30 \uB54C\uBB38\uC5D0 warning\uC774 \uBC1C\uC0DD\uD569\uB2C8\uB2E4.\n        prefix\uB85C $\uB97C \uBD99\uC774\uBA74 \uD574\uB2F9 prop\uC774 a \uD0DC\uADF8\uB85C \uC804\uD574\uC9C0\uB294 \uAC83\uC744 \uBC29\uC9C0\uD558\uAE30 \uB54C\uBB38\uC5D0 warning\uC744 \uBC29\uC9C0\uD560 \uC218 \uC788\uC2B5\uB2C8\uB2E4.\n    */\n    ", "\n    color: ", ";\n    ", "\n"])), LinkStyle, function (props) {
  return props.color;
}, function (props) {
  return props.$showUnderline && (0, _styledComponents.css)(_templateObject3 || (_templateObject3 = _taggedTemplateLiteral(["\n            &:hover {\n                border-bottom: solid 1px ", ";\n            }\n        "])), props.color);
});
/**
 * Link를 표시할 때 사용합니다. OpizeWrapper의 initLink가 없다면 <a> 태그로 작동합니다.
 */
var Link = /*#__PURE__*/_react.default.forwardRef(function (_ref, ref) {
  var as = _ref.as,
    to = _ref.to,
    color = _ref.color,
    _ref$newTab = _ref.newTab,
    newTab = _ref$newTab === void 0 ? false : _ref$newTab,
    _ref$showIcon = _ref.showIcon,
    showIcon = _ref$showIcon === void 0 ? false : _ref$showIcon,
    children = _ref.children,
    _ref$showUnderline = _ref.showUnderline,
    showUnderline = _ref$showUnderline === void 0 ? true : _ref$showUnderline,
    props = _objectWithoutProperties(_ref, _excluded);
  var _useContext = (0, _react.useContext)(_linkContext.LinkContext),
    LinkA = _useContext.Link;
  var Element = as || LinkA || 'a';
  return /*#__PURE__*/_react.default.createElement(StyledLink, _extends({}, props, {
    href: to,
    to: to,
    target: newTab ? '_blank' : '_self',
    rel: "noreferrer",
    color: color || _style.cv.blue1,
    $showUnderline: showUnderline,
    ref: ref,
    as: Element
  }), children, showIcon && /*#__PURE__*/_react.default.createElement(_phosphorReact.Share, {
    size: 16,
    color: color || _style.cv.blue1,
    weight: "bold",
    style: {
      marginLeft: '4px',
      marginBottom: '-2px'
    }
  }));
});
exports.Link = Link;