"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.ColorThemeContext = void 0;
var _react = _interopRequireWildcard(require("react"));
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }
function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
var ColorThemeContext = /*#__PURE__*/(0, _react.createContext)({
  colorTheme: 'system',
  nowColorTheme: 'light',
  setColorTheme: function setColorTheme() {
    return null;
  }
});
exports.ColorThemeContext = ColorThemeContext;
function ColorThemeProvider(_ref) {
  var children = _ref.children;
  var _useState = (0, _react.useState)('system'),
    _useState2 = _slicedToArray(_useState, 2),
    colorTheme = _useState2[0],
    setColorTheme = _useState2[1];
  var _useState3 = (0, _react.useState)('light'),
    _useState4 = _slicedToArray(_useState3, 2),
    nowColorTheme = _useState4[0],
    setNowColorTheme = _useState4[1];
  (0, _react.useEffect)(function () {
    var savedTheme = typeof window === 'undefined' ? 'light' : localStorage.getItem('theme');
    if (savedTheme === 'dark') {
      setColorTheme('dark');
      setNowColorTheme('dark');
      return;
    }
    if (savedTheme === 'light') {
      setColorTheme('light');
      setNowColorTheme('light');
      return;
    }
    var isUserDark = window.matchMedia && window.matchMedia('(prefers-color-scheme: dark)').matches;
    setColorTheme('light');
    setNowColorTheme(isUserDark ? 'dark' : 'light');
  }, []);
  var changeColorTheme = (0, _react.useCallback)(function (theme) {
    if (theme === 'system') {
      var _document$querySelect;
      setColorTheme('system');
      setNowColorTheme(window.matchMedia && window.matchMedia('(prefers-color-scheme: dark)').matches ? 'dark' : 'light');
      (_document$querySelect = document.querySelector('body')) === null || _document$querySelect === void 0 ? void 0 : _document$querySelect.removeAttribute('data-theme');
      if (typeof window !== 'undefined') localStorage.removeItem('theme');
    } else if (theme === 'dark') {
      var _document$querySelect2;
      setColorTheme('dark');
      setNowColorTheme('dark');
      (_document$querySelect2 = document.querySelector('body')) === null || _document$querySelect2 === void 0 ? void 0 : _document$querySelect2.setAttribute('data-theme', 'dark');
      if (typeof window !== 'undefined') localStorage.setItem('theme', 'dark');
    } else if (theme === 'light') {
      var _document$querySelect3;
      setColorTheme('light');
      setNowColorTheme('light');
      (_document$querySelect3 = document.querySelector('body')) === null || _document$querySelect3 === void 0 ? void 0 : _document$querySelect3.setAttribute('data-theme', 'light');
      if (typeof window !== 'undefined') localStorage.setItem('theme', 'light');
    }
  }, []);
  var value = (0, _react.useMemo)(function () {
    return {
      setColorTheme: changeColorTheme,
      colorTheme: colorTheme,
      nowColorTheme: nowColorTheme
    };
  }, [changeColorTheme, colorTheme, nowColorTheme]);
  return /*#__PURE__*/_react.default.createElement(ColorThemeContext.Provider, {
    value: value
  }, children);
}
var _default = ColorThemeProvider;
exports.default = _default;