"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.themes = exports.themedPalette = exports.themeVariableSets = void 0;
// TODO: #3 black 테마 추가시 box-shadow에 대한 수정 필요
var themeVariableSets = {
  light: {
    white: '#fff',
    black: '#000',
    bg_page1: '#F8F9FA',
    bg_page2: '#FFFFFF',
    bg_element1: '#FFFFFF',
    bg_element1_1: '#fcfcfc',
    bg_element2: '#F5F6F8',
    bg_element3: '#E9ECEF',
    bg_element4: '#DEE2E6',
    bg_element5: '#212529',
    bg_element6: '#343A40',
    border1: '#343A40',
    border2: '#ADB5BD',
    border3: '#c9d1da',
    border4: '#e5e9ec',
    outline: 'rgba(43, 153, 255, 0.4)',
    text1: '#212529',
    text2: '#495057',
    text3: '#9199a1',
    text4: '#CED4DA',
    text5: '#FFFFFF',
    red1: 'rgba(216, 80, 74, 1)',
    bg_red1: 'rgba(216, 80, 74, 0.2)',
    bg_red1_hover: 'rgba(216, 80, 74, 0.3)',
    yellow1: 'rgba(250, 175, 0, 1)',
    bg_yellow1: 'rgba(250, 175, 0, 0.2)',
    bg_yellow1_hover: 'rgba(250, 175, 0, 0.3)',
    green1: 'rgba(57, 183, 93, 1)',
    bg_green1: 'rgba(57, 183, 93, 0.2)',
    bg_green1_hover: 'rgba(57, 183, 93, 0.3)',
    blue1: 'rgba(32, 151, 246, 1)',
    bg_blue1: 'rgba(32, 151, 246, 0.2)',
    bg_blue1_hover: 'rgba(32, 151, 246, 0.3)'
  },
  dark: {
    white: '#fff',
    black: '#000',
    bg_page1: '#252629',
    bg_page2: '#1a1b1d',
    bg_element1: '#1a1b1d',
    bg_element1_1: '#252629',
    bg_element2: '#313238',
    bg_element3: '#404147',
    bg_element4: '#5a5c64',
    bg_element5: '#ecf0f3',
    bg_element6: '#e2e6eb',
    border1: '#ecf0f3',
    border2: '#8d959b',
    border3: '#3a3c42',
    border4: '#26282b',
    outline: 'rgba(43, 153, 255, 0.4)',
    text1: '#f2f5f8',
    text2: '#95a0aa',
    text3: '#6a7179',
    text4: '#464b50',
    text5: '#000000',
    red1: 'rgba(216, 80, 74, 1)',
    bg_red1: 'rgba(216, 80, 74, 0.2)',
    bg_red1_hover: 'rgba(216, 80, 74, 0.3)',
    yellow1: 'rgba(250, 175, 0, 1)',
    bg_yellow1: 'rgba(250, 175, 0, 0.2)',
    bg_yellow1_hover: 'rgba(250, 175, 0, 0.3)',
    green1: 'rgba(57, 183, 93, 1)',
    bg_green1: 'rgba(57, 183, 93, 0.2)',
    bg_green1_hover: 'rgba(57, 183, 93, 0.3)',
    blue1: 'rgba(32, 151, 246, 1)',
    bg_blue1: 'rgba(32, 151, 246, 0.2)',
    bg_blue1_hover: 'rgba(32, 151, 246, 0.3)'
  }
};
exports.themeVariableSets = themeVariableSets;
var buildCssVariables = function buildCssVariables(variables) {
  var keys = Object.keys(variables);
  return keys.reduce(function (acc, key) {
    return acc.concat("--".concat(key.replace(/_/g, '-'), ": ").concat(variables[key], ";"), '\n');
  }, '');
};
var themes = {
  light: buildCssVariables(themeVariableSets.light),
  dark: buildCssVariables(themeVariableSets.dark)
};
exports.themes = themes;
var cssVar = function cssVar(name) {
  return "var(--".concat(name.replace(/_/g, '-'), ")");
};
var variableKeys = Object.keys(themeVariableSets.light);
var themedPalette = variableKeys.reduce(function (acc, current) {
  acc[current] = cssVar(current);
  return acc;
}, {});
exports.themedPalette = themedPalette;